'' First, place your camera and projector in the desired location, then you should focus your lenses using the Projectline--UserinterfaceProp.spin
'' and the focuslens--cameraprop.spin.  Then and only then are you ready to calibrate your
'' camera using this object.

'' The purpose of this object is
''  1.  to create measurements, which will accurately estimate the visual angle of sensors element and
''    2.  to measure the alignment of the sensors.

''This objects uses a Gigaware Microprojector (connected to the
''user interface prop) to project video(or VGA) images of two vertical lines... one at the left side and one at the right side of the screen, and then
''find the 4 sensor elements (2 from the left sensor... and 2 from the right), which correspond to the horizontal locations of the vertical lines.
''The object then monitors these sensor elements and finds the exact vertical location on the screen
''responsible for the correspondance.  This identifies two point pairs, which are then
''displayed on the screen as left camera sensor/left most sensor element(LP1).  Left camera postion/
''right most sensor element, (LP2).  The other pair ( for the right sensor) is identified
''as RP1 and RP2.  The center of a line connecting LP1 and LP2 is then calculated and the
''a routine  finds the exact screen location corresponding to the center sensor element of the left sensor. The process
''does the same procedure for the right sensor.

''The resulting data is then displayed on the screen for subsequent measurement purposes.


''
'' Legal use:

''As with everything  I post to the forum, this code is free for use for any purpose, with or without attribution... so long as the original authors of supporting Objects
''do not indicate otherwise.

''rjo  Feb-March 2010



CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 1
  bpin =20  'video basepine
  indicator = 1

  tsl_clk  =8
  tsl_si   = 9
  mcp_clk  = 15
  mcp_data = 13
  mcp_cs   = 12
  triggerIn  = 2          'trigger in
  channel  = 0    'mcp base channel
  remote  = 4

VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[16]
  long range,center,voffset,maxval,minval,cmd,t1,tip,maxdifflpix,noisefloor,temp,estimate_center

  long ok,sumdiffl,sumpixelindexL,sumdiffr,sumpixelindexR,Lpixel_Loc,Rpixel_Loc,docorr
  word maxR,maxL,maxL_loc ,maxR_loc
  long maxdiffrpix,aL,aR,aP,gotangle,pD,distance,lastdistance,lp1,lp2,rp1,rp2,Lcenterline,Rcenterline
  word dataL[128],dataR[128]     
OBJ
  'io    :"FullDuplexSerial"
  tv    : "tv"
  gr    : "graphics2"
  MCP   : "MCP3208_fast_rjo"
  tsl   : "tsl1401asm_rjo_001"
PUB start | i,line,tempval1,yy,temploc1,temploc2,tempval2,tempval3,tempval4,temploc3,temploc4,char
  'io.start(10,11,0,115200)
  InitParams
  gr.start
  mcp.start(mcp_data,mcp_clk,mcp_cs)
  gr.setup(16, 12, 128, 96, bitmap_base)
  dira[tsl_clk]:=dira[tsl_si]:=1
  cmd:=1
  tsl.start(@cmd)
  repeat until cmd == 0
  getimage
  getimage
  plot
  waitcnt(clkfreq*5 + cnt)
  repeat 1
     Map_pixel2Line(100)
     lp2:=lPixel_loc
     rp2:=rPixel_loc
     Map_Pixel2line(-100)
     lp1:=lpixel_loc
     rp1:=rpixel_loc
     

     blankscreen

  tempval2:=0
  tempval1:=0
  tempval3:=0
  tempval4:=0
  
  repeat  yy from -90 to 90
    blankscreen
    gr.plot(100,yy-1)
    gr.line(100,yy+1)
    gr.plot(-100,yy-1)
    gr.line(-100,yy+1)
    gr.plot(0,85)
    gr.line(20,85)
    gr.copy(display_base)
    

    getimage
    blankscreen
    subtractimage
    if dataL[lp2] > tempval2
       tempval2:=dataL[lp2]
       temploc2:=yy
    if datal[lp1]>tempval1
        tempval1:=datal[lp1]
        temploc1:=yy

    if datar[rp2] > tempval3
       tempval3:=datar[rp2]
       temploc3:=yy
    if datar[rp1] > tempval4
       tempval4:=datar[rp2]
       temploc4:=yy

       
  blankscreen
  MapLinetoCenterPixels(64)
  blankscreen
  gr.plot(100,temploc2)
 
  gr.line(-100,temploc1)
  gr.colorwidth(3,0)
  gr.plot(100,temploc4)
  gr.line(-100,temploc3)
  gr.colorwidth(2,0)

                                           
  gr.text(-127,0,@lp1_)
  gr.text(-127,-30,@rp1_)
  gr.text(70,0,@lp2_)
  gr.text(70,-30,@rp2_)
  plotint(lp1,-87,0)
  plotint(rp1,-87,-30)
  plotint(lp2,114,0)
  plotint(RP2,114,-30)
  gr.plot(Lcenterline,-70)
  gr.line(Lcenterline,70)
  char:="L"
  gr.text(Lcenterline,-84,@char)

  gr.plot(Rcenterline,-70)
  gr.line(Rcenterline,70)
  char:="R"
  gr.text(Rcenterline,-84,@char)
  gr.text(70,70,@prop)

  plotint(rcenterline,rcenterline-20,60)
  plotint(lcenterline,lcenterline-20,-60)
  gr.copy(display_base)

  
                      

  repeat

pub Blankscreen
    gr.clear
    gr.copy(display_base)
    
pub MapLinetoCenterPixels(whichpixel) | ii,startline,finishline,tempval,temploc
    tempval:=0
    estimate_center:=-100+  (( (whichpixel-lp1)*200/(lp2-lp1) ))
    startline:=estimate_center-4
    finishline:=estimate_center+4
    repeat  ii from startline to finishline
       blankscreen
       plotline(ii)
       
       getimage
       blankscreen
       subtractimage
       if dataL[whichpixel] > tempval
          tempval := dataL[whichpixel]
          temploc:=ii
    Lcenterline:=temploc
                                        
    estimate_center:=-100+((whichpixel-rp1)*200/(rp2-rp1) )
    startline:=estimate_center-8
    finishline:=estimate_center+8
    tempval:=0
    repeat  ii from startline to finishline
       blankscreen
       plotline(ii)
       
       getimage
       blankscreen
       subtractimage
       if dataR[whichpixel] > tempval
          tempval := dataR[whichpixel]
          temploc:=ii          
     Rcenterline:=temploc       
pub Map_Pixel2Line(whichline)
  repeat 1
    blankscreen
    plotline(whichline)
    waitcnt(clkfreq/3 + cnt)
    'getimage
    getimage
    blankscreen
    waitcnt(clkfreq/3 + cnt)
    subtractimage
    find_corresponding_pixels
    plot
    waitcnt(clkfreq*1 + cnt)
    blankscreen
    
    
Pub find_corresponding_pixels  | testpixel ,wtdiff,wtdiff_r,j,testpixel_r,noisefloor_l,noisefloor_r
    sumdiffL:=0
    sumdiffR:=0
    wtdiff:=0
    getmax
    noisefloor_L:=(maxL * 80)/100
    noisefloor_R:=(maxR *80)/100
    sumpixelindexL:=0
    sumpixelindexR:=0
    wtdiff_r:=0
    repeat  j from 0 to 126
       testpixel := dataL[j]
       testpixel_r:=dataR[j]
       if testpixel > noisefloor_l
            wtdiff:=wtdiff + (testpixel*j)
            sumdiffl:=sumdiffl+testpixel
            sumpixelindexL:=sumpixelindexL + j          
       if testpixel_r > noisefloor_r
            wtdiff_r:=wtdiff_r + (testpixel_r*(j))
            sumdiffr:=sumdiffr+testpixel_r
            sumpixelindexr:=sumpixelindexr + (j)


    Rpixel_loc:=wtdiff_r/sumdiffR      
    Lpixel_loc:= wtdiff/sumdiffl

Pub GetMax    | j
    maxL:=0
    maxR:=0
    repeat  j from 0 to 126
       if datal[j]  > maxL
          maxL:=datal[j]
          maxL_loc:=j
       if dataR[j]  > MaxR
          maxR:=dataR[j]
          maxR_loc:=j
    

pub getimage | i,tester
 cmd:=1

 repeat until cmd==0
 i:=0

 repeat 128
      outa[tsl_clk]:=1 
      outa[tsl_clk]:=0 
      datar[i]:=(mcp.in(channel))
      datal[i]:=(mcp.in(channel+1))
      i++

Pub SubtractImage | i
 i:=0
 cmd:=1

 repeat until cmd==0

 repeat 128
      outa[tsl_clk]:=1 
      outa[tsl_clk]:=0 
      
      datal[i]:=||(datal[i]-(mcp.in(channel+1)) )
      datar[i]:=||(datar[i]-(mcp.in(channel)))
      i++


pub plot  |i, j,jj,k, kk,px,py,dechr,gotleft,gotright

    gr.clear
   ' gr.text(64,80,@pchip)

    range:=3
    gr.colorwidth(2,0)
    repeat i from 0 to 126
      px:=i-128
      py:= ((dataL[i])/range)-voffset
      gr.plot(px,-voffset)
      gr.line(px,py)
      px:=i
      py:= ((dataR[i])/range  )-voffset
      gr.plot(px,-voffset)
      gr.line(px,py)
                  
    gr.colorwidth(3,0)
    dechr:="L"
    gr.text(-64,-92,@dechr)
    dechr:="R"
    gr.text(64,-92,@dechr)
    gr.text(-90,80,@PixelVal)
    gr.text(-120,70,@LeftPixel_)
    gotleft:=1

               '
                                    't1 is total clocks in integration period, t1 is written by pasm routine
                                    'in tsl1401asm_rjo_001
    plotint(lPixel_loc,-40,70)
    plotint(rpixel_loc,-40,55)
   ' plotint(101,-40,70)                'write integration period to screen

                   'write integration period to screen
    plotInt(range,-60,80)
    
    gr.color(2)

    gr.colorwidth(2,0)
    gr.copy(display_base)
Pub PlotLine(whichline)

      gr.plot (whichline,-100)
      gr.line (whichline,100)
      gr.copy(display_base)

Pub plotInt (value,x,y) | i,kk,dechr,sign
    sign:="+"
    i:=0
    if value < 0
       value:=-value
       sign:="-"
                               
    repeat until value == 0
       kk:=value//10
       value:=value/10
       dechr:=num +kk
       gr.text(x-(i*6),y,@dechr)
       i:=i+1 
    gr.text(x-(i*6),y,@sign)

    
Pub InitParams   | i,dx,dy
  Tip:=30000         'TSL integration period parameter....integration clocks =  3136 + (448*tip)
  voffset:=94    'adjusts plot x,y location.  Can be used in future to implement full windowing logic
  noisefloor:=50
  pD:=74
  longmove(@tv_status, @tvparams, paramcount)
  
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)
  repeat i from 0 to 16
    colors[i] := $00001010 * (i+20) & $F + $2B060C02
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
                             
 

 
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long     (bpin & $38) << 1 | (bpin & 4 == 4) & %0101 
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog

                        
Prop                    byte    "Propeller",0
LeftPixel_              byte    "Left Pixel=",0
PixelVal                byte    "Pix/ ",0
lp1_                    byte    "LP1 = ",0
lp2_                    byte    "LP2 = ",0
rp1_                    byte    "RP1 = ",0
rp2_                    byte    "RP2 = ",0
'pchip                   byte    "Propeller",0           'text
num                     byte    "0",0,"1",0,"2",0,"3",0,"4",0,"5",0,"6",0,"7",0,"8",0,"9",0